<?php
################################################################################
# @Name : mail2ticket.php
# @Desc : convert mail in ticket
# @call : 
# @parameters : 
# @Author : Flox
# @Create : 07/04/2013
# @Update : 26/11/2015
# @Version : 3.1.1
################################################################################

//initialize counter
$count=0;

//connexion script with database parameters
require "connect.php";

//define current time
$datetime = date("Y-m-d H:i:s");

//load parameters table
$query=$db->query("SELECT * FROM tparameters");
$rparameters=$query->fetch();
$query->closeCursor(); 

//hostname building
$hostname = '{'.$rparameters['imap_server'].':'.$rparameters['imap_port'].'}'.$rparameters['imap_inbox'].'';

//connect to inbox

//default case
$inbox = imap_open($hostname,$rparameters['imap_user'],$rparameters['imap_password']) or die('Impossible de se connecter au serveur de Messagerie: ' . imap_last_error());

// Exchange 2010
//$inbox = imap_open('{'.$rparameters['imap_server'].':'.$rparameters['imap_port'].'/pop3/novalidate-cert}'.$rparameters['imap_inbox'].'', $rparameters['imap_user'], $rparameters['imap_password'],NULL,1,array('DISABLE_AUTHENTICATOR'=>'GSSAPI')) or die('Impossible de se connecter au serveur de Messagerie: ' . imap_last_error());


//display header
echo'
<html lang="fr">
	<head>
		<meta charset="UTF-8" />
	</head>
';

if($inbox) 
{ 
	//grab mail
	echo "<u></u>Connexion à la boite au lettre en cours: <font color=green>ok</font><br /><br />";
	$emails = imap_search($inbox,'ALL');
	 //if emails are returned
    if($emails) {
		//for every email...
		foreach($emails as $email_number) {
			//get information specific to this email
			$overview = imap_fetch_overview($inbox, $email_number, 0);
			$seen=$overview[0]->seen;
			//if message is not read
			if ($seen==0)
			{
				$count=$count+1;
				//get mail data
				$message = imap_fetchbody($inbox, $email_number, 1);
				$message = nl2br($message);
				
				$header = imap_headerinfo($inbox, $email_number);
				$subject = $overview[0] -> subject;
				$from = $header->from[0]->mailbox . "@" . $header->from[0]->host;
				
				//special char convert
				$message=quoted_printable_decode($message);
				mb_internal_encoding('UTF-8');
				$subject=mb_decode_mimeheader($subject);
				$subject = str_replace('_', ' ', $subject);
				
				//Escape special char to SQL query
				$subject=$db->quote($subject);
				$message = str_replace("'", "\'", $message);
			
				//find gestsup userid from mail address
				$db->query("SELECT id FROM `tusers` where mail='$from' ");
				$row=$query->fetch();
				$query->closeCursor();
				if($row[0])
				{
					$user_id=$row[0];
				} else {
					$user_id='0';
					$message='De '.$from.':<br />'.$message;	
				}
				/*
				echo " sujet : $subject <br /><br />";
				echo " message : $message <br /><br />";
				echo " req :

								 INSERT INTO tincidents  (user,technician,title,description,date_create,techread,state,criticality,disable) VALUES ('$user_id','0',$subject, '$message','$datetime','0','5','4','0')


				<br /><br />";
				*/
				// create ticket
				$db->exec("INSERT INTO tincidents  (user,technician,title,description,date_create,techread,state,criticality,disable) VALUES ('$user_id','0',$subject, '$message'	,'$datetime','0','5','4','0')");
				echo "&nbsp> Import du message $count: $subject: <font color=green>ok</font><br />";
			}
		}
	}
	imap_close($inbox);
	echo "<br />Total: Récupération de $count messages depuis <b>$rparameters[imap_server]</b> depuis le port <b>$rparameters[imap_port]</b><br />";

} else {
	echo "Erreur de connexion IMAP";
}
echo '</html>';
?>